
Global projekt$
Global ebene_anz%


'Open/Save Dialog Flags
Global Const OFN_READONLY = &H1
Global Const OFN_OVERWRITEPROMPT = &H2
Global Const OFN_HIDEREADONLY = &H4
Global Const OFN_NOCHANGEDIR = &H8
Global Const OFN_SHOWHELP = &H10
Global Const OFN_ENABLEHOOK = &H20
Global Const OFN_ENABLETEMPLATE = &H40
Global Const OFN_ENABLETEMPLATEHANDLE = &H80
Global Const OFN_NOVALIDATE = &H100
Global Const OFN_ALLOWMULTISELECT = &H200
Global Const OFN_EXTENSIONDIFFERENT = &H400
Global Const OFN_PATHMUSTEXIST = &H800
Global Const OFN_FILEMUSTEXIST = &H1000
Global Const OFN_CREATEPROMPT = &H2000
Global Const OFN_SHAREAWARE = &H4000
Global Const OFN_NOREADONLYRETURN = &H8000
Global Const OFN_NOTESTFILECREATE = &H10000
Global Const OFN_SHAREFALLTHROUGH = 2
Global Const OFN_SHARENOWARN = 1
Global Const OFN_SHAREWARN = 0

Type OpenSaveFile
     lStructSize As Long
     hwndOwner As Integer
     hInstance As Integer
     lpstrFilter As Long
     lpstrCustomFilter As Long
     nMaxCustFilter As Long
     nFilterIndex As Long
     lpstrFile As Long
     nMaxFile As Long
     lpstrFileTitle As Long
     nMaxFileTitle As Long
     lpstrInitialDir As Long
     lpstrTitle As Long
     Flags As Long
     nFileOffset As Integer
     nFileExtension As Integer
     lpstrDefExt As Long
     lCustData As Long
     lpfnHook As Long
     lpTemplateName As Long
End Type

Declare Function GetOpenFileName Lib "COMMDLG.DLL" (pOpenSaveFile As OpenSaveFile) As Integer
Declare Function GetSaveFileName Lib "COMMDLG.DLL" (pOpenSaveFile As OpenSaveFile) As Integer

Declare Sub hmemcpy Lib "Kernel" (lpDest As Any, lpSource As Any, ByVal dwBytes As Long)
Declare Function Lstrcpy Lib "KERNEL" (p1 As Any, p2 As Any) As Long
Declare Function GlobalAlloc Lib "Kernel" (ByVal wFlags As Integer, ByVal dwBytes As Long) As Integer
Declare Function GlobalFree Lib "Kernel" (ByVal hMem As Integer) As Integer
Declare Function GlobalLock Lib "Kernel" (ByVal hMem As Integer) As Long
Declare Function GlobalUnlock Lib "Kernel" (ByVal hMem As Integer) As Integer
Global Const GMEM_MOVEABLE = &H2
Global Const GMEM_ZEROINIT = &H40
Global Const GHND = (GMEM_MOVEABLE Or GMEM_ZEROINIT)



Global Const MAX_PATH = 32

Type FILETIME
   dwLowDateTime As Long
   dwHighDateTime As Long
End Type

Type WIN32_FIND_DATA
   dwFileAttributes As Long
   ftCreationTime As FILETIME
   ftLastAccessTime As FILETIME
   ftLastWriteTime As FILETIME
   nFileSizeHigh As Long
   nFileSizeLow As Long
   dwReserved0 As Long
   dwReserved1 As Long
   cFilename As String * MAX_PATH
   cAlternate As String * 14
End Type

Declare Function GetProcAddress32W Lib "kernel" (ByVal hModule As Long, ByVal lpProcName As String) As Long
Declare Function LoadLibraryEx32W Lib "kernel" (ByVal lpLibFileName As String, ByVal hFile As Long, ByVal dwFlags As Long) As Long
Declare Function FreeLibrary32W Lib "kernel" (ByVal hInst As Long) As Long
Declare Function GetShortPathNameA Lib "kernel" Alias "CallProc32W" (ByVal lpszLongPath As String, ByVal lpszShortPath As String, ByVal cchBuffer As Long, ByVal Funktion As Long, ByVal adr As Long, ByVal Params As Long) As Long

Function addpfad$ (pfaddat$, ByVal F$)

If Left$(F$, 2) = ".." Then
   p$ = showpath$(pfaddat$)
   Do While Left$(F$, 3) = "..\"
      p$ = showpath$(get_pfad$(p$)): F$ = Mid$(F$, 4)
   Loop
   addpfad$ = p$ + "\" + F$
ElseIf Mid$(F$, 2, 2) = ":\" Then
   addpfad$ = F$
ElseIf Left$(F$, 1) = "\" Then
   addpfad$ = F$
Else
   addpfad$ = pfaddat$ + F$
End If

End Function

Function aufgerufene_proc$ (p%)

a$ = ""
For n% = Baum.ProcListe.ItemData(p% - 1) + 1 To Baum.Tree.ListCount
   If Baum.Tree.Indent(n% - 1) = 1 Then Exit For
   If Baum.Tree.Indent(n% - 1) = 2 Then
      c$ = Baum.Tree.List(n% - 1)
      If Left$(c$, 1) = "(" Then c$ = Mid$(c$, 2, Len(c$) - 2)
      For i% = 1 To Baum.ProcListe.ListCount
         If Baum.ProcListe.List(i% - 1) = c$ Then a$ = a$ + Str$(i%) + ";": Exit For
      Next
   End If
Next

aufgerufene_proc$ = a$

End Function

Sub baum_anzeigen ()
   
'Anzeigen des Baums

maus 0
Baum.Tree.Clear

'On Error GoTo xfehler

Open get_pfad$(projekt$) + zeichennext$(get_file$(projekt$), ".") + ".str" For Input As #1
Do Until EOF(1)
   Line Input #1, a$: a$ = Trim$(a$)
   If Left$(a$, 1) = "[" And Right$(a$, 1) = "]" Then
      root$ = Mid$(a$, 2, Len(a$) - 2)
      Baum.Tree.AddItem root$
      Baum.Tree.Indent(Baum.Tree.ListCount - 1) = 1
      unterpunkt root$, 2, "|" + root$ + "|"
   End If
Loop

ok:
Close #1
maus 1
Exit Sub

'Fehler aufgetreten, vermutlich Speicher nicht ausreichend
xfehler:
Baum.Tree.Clear
Baum.Tree.AddItem "Speicher nicht ausreichend"
Baum.Tree.Indent(0) = 0
Baum.menu_grafik.Enabled = False
Resume ok

End Sub

Function Dialog_Open$ (F As Form, ByVal ftitle$, fpfad$, ByVal ffile$, ByVal ffilter$, ByVal fext$)

Dim rc%, filesize%, MemHndl%, MemAddr&, osFile As OpenSaveFile
Dialog_Open$ = ""

dr$ = CurDir$

ersetze ffilter$, "|", Chr$(0)
ffilter$ = ffilter$ & Chr$(0) & Chr$(0)

ffile$ = ffile$ & String$(128 - Len(ffile$), 0)
filesize% = Len(ffile$) + Len(ffilter$)

MemHndl% = GlobalAlloc(GHND, filesize%)
If MemHndl% = False Then Exit Function
MemAddr& = GlobalLock(MemHndl%)

Call hmemcpy(ByVal MemAddr&, ByVal (ffile$ + ffilter$ + ftitle$), filesize%)
osFile.lStructSize = Len(osFile)
osFile.hwndOwner = F.hWnd

osFile.Flags = osFile.Flags Or OFN_HIDEREADONLY Or OFN_PATHMUSTEXIST
osFile.nFilterIndex = 1
osFile.lpstrFile = MemAddr&
osFile.nMaxFile = Len(ffile$)
osFile.lpstrFilter = MemAddr& + Len(ffile$)
osFile.lpstrTitle = Lstrcpy(ByVal ftitle$, ByVal ftitle$)
osFile.lpstrDefExt = Lstrcpy(ByVal fext$, ByVal fext$)

If Len(Trim$(fpfad$)) Then  'Convert fpfad$ to a LONG integer
   fpfad$ = showpath$(fpfad$)
   osFile.lpstrInitialDir = Lstrcpy(ByVal fpfad$, ByVal fpfad$)
End If

osFile.Flags = osFile.Flags Or OFN_FILEMUSTEXIST
rc% = GetOpenFileName(osFile)

If rc% <> False Then
   Call hmemcpy(ByVal ffile$, ByVal MemAddr&, Len(ffile$))
   a$ = LCase$(Left$(ffile$, InStr(ffile$, Chr$(0)) - 1))
   Dialog_Open$ = get_file$(a$)
   fpfad$ = get_pfad$(a$)
End If
rc% = GlobalUnlock(MemHndl%)
rc% = GlobalFree(MemHndl%)

ChDir dr$

End Function

Sub ersetze (a$, b$, c$)

If InStr(c$, b$) > 0 And Len(b$) > 0 Then Exit Sub

Do While InStr(a$, b$)
   a$ = Left$(a$, InStr(a$, b$) - 1) + c$ + Mid$(a$, InStr(a$, b$) + Len(b$))
Loop

End Sub

Function exist% (a$)

On Error Resume Next
tmp% = Len(Dir$(a$, 6))
If Err Or tmp% = 0 Then
   exist% = 0
ElseIf GetAttr(a$) And 16 Then
   exist% = 0
Else
   exist% = 1
End If

End Function

Function formname$ (ByVal frm$)
      
If exist%(frm$) Then
   Open frm$ For Input As #2
   Line Input #2, a$
   Line Input #2, a$
   Close #2
   
   b$ = zeichennext$(a$, " "): a$ = Trim$(a$)
   b$ = zeichennext$(a$, " "): a$ = Trim$(a$)
   formname$ = a$
Else
   formname$ = "???"
End If

End Function

Function get_file$ (ByVal a$)
   
Do While InStr(a$, ":")
   F$ = zeichennext$(a$, ":")
Loop
Do While InStr(a$, "\")
   F$ = zeichennext$(a$, "\")
Loop

get_file$ = Trim$(a$)

End Function

Function get_pfad$ (ByVal a$)

p$ = ""
Do While InStr(a$, ":")
   p$ = p$ + zeichennext$(a$, ":") + ":"
Loop
Do While InStr(a$, "\")
   p$ = p$ + zeichennext$(a$, "\") + "\"
Loop

get_pfad$ = Trim$(p$)

End Function

Function innen% (zeile$, proc$)

'innen%=0:  proc$ ist in zeile$ nicht enthalten
'      =1:  proc$ ist in zeile$ enthalten (und = folgt nicht)

innen% = 0

kommentar% = InStr_Ex(1, zeile$, "'")
If kommentar% Then zeile$ = Left$(zeile$, kommentar% - 1)

If Trim$(zeile$) = "" Then Exit Function

ab% = 1
Do
   F% = 0
   st% = InStr_Ex(ab%, zeile$, proc$): If st% = 0 Then Exit Function

   x$ = LCase$(Mid$(" " + zeile$, st%, 1))
   If (x$ >= "a" And x$ <= "z") Or x$ = "_" Then F% = 1

   x$ = LCase$(Mid$(zeile$, st% + Len(proc$), 1))
   If Len(x$) = 1 And ((x$ >= "a" And x$ <= "z") Or x$ = "_") Then F% = 1
   
   If Left$(Trim$(Mid$(zeile$, st% + Len(proc$))), 1) = "=" Then F% = 1
   
   ab% = st% + 1
Loop While F%

innen% = 1

End Function

Function InStr_Ex (ByVal ab%, a$, b$) As Integer

'Erweiterte InStr-Funktion:
'Fundstellen innerhalb "..." werden nicht bercksichtigt

InStr_Ex = 0
ab0% = ab%

Do
   t% = InStr(ab%, a$, b$): If t% = 0 Then Exit Function

   z% = -1: pos% = ab0% - 1
   Do
      z% = z% + 1
      pos% = InStr(pos% + 1, a$, Chr$(34))
   Loop Until pos% = 0 Or pos% >= t%

   'in z% sind jetzt die Anzahl " zwischen ab0% und t%-1

   ab% = t% + 1
Loop While z% Mod 2

InStr_Ex = t%

End Function

Function is_sub_or_function% (ByVal a$)

a$ = Trim$(a$)
a1$ = zeichennext$(a$, " ")

If a1$ = "Sub" Or a1$ = "Function" Then
   is_sub_or_function% = True
ElseIf a1$ = "Public" Or a1$ = "Private" Then
   a$ = Trim$(a$)
   a1$ = zeichennext$(a$, " ")
   If a1$ = "Sub" Or a1$ = "Function" Then
      is_sub_or_function% = True
   Else
      is_sub_or_function% = False
   End If
Else
   is_sub_or_function% = False
End If

End Function

Sub maus (m%)

Screen.MousePointer = 11 - 11 * m%

End Sub

Function ShortFilename$ (a$)

hInst& = LoadLibraryEx32W("Kernel32.dll", 0&, 0&)

Dim ShortFile As String * 256

lpShort& = GetProcAddress32W(hInst&, "GetShortPathNameA")
l& = GetShortPathNameA(a$, ShortFile, 256&, lpShort&, 6&, 3&)

ShortFilename$ = Left$(ShortFile, l&)

l& = FreeLibrary32W(hInst&)

End Function

Function showpath$ (a$)

If Right$(a$, 1) = "\" And Mid$(a$, 2) <> ":\" Then
  showpath$ = Left$(a$, Len(a$) - 1)
Else
  showpath$ = a$
End If

End Function

Sub unterpunkt (fu$, ebene%, full$)

' Eintrag aller Funktionen in die Ebene 'ebene%', welche die
' Funktion 'fu$' aufrufen.
' Nicht weiter untersuchen: Funktionen, die schon in 'full$'
' enthalten sind

' s$ stellt nur einmaligen Eintrag sicher

nr% = FreeFile: F% = 0
Open get_pfad$(projekt$) + zeichennext$(get_file$(projekt$), ".") + ".str" For Input As #nr%
Do Until EOF(nr%)
   Line Input #nr%, a$: a$ = Trim$(a$)
   If Left$(a$, 1) = "[" And Right$(a$, 1) = "]" Then
      If F% Then Exit Do
      If Mid$(a$, 2, Len(a$) - 2) = fu$ Then F% = 1
   ElseIf Len(a$) > 0 And F% = 1 Then
      If InStr(full$, "|" + a$ + "|") Then
         Baum.Tree.AddItem "(" + a$ + ")"
         Baum.Tree.Indent(Baum.Tree.ListCount - 1) = ebene%
      Else
         Baum.Tree.AddItem a$
         Baum.Tree.Indent(Baum.Tree.ListCount - 1) = ebene%
         If Baum.menu_tiefe(2).Checked Then unterpunkt a$, ebene% + 1, full$ + a$ + "|"
      End If
   End If
Loop
Close #nr%

End Sub

Function zeichennext$ (a$, ch$)

ai% = InStr(a$, ch$)
If ai% = 0 Then
  zeichennext$ = a$: a$ = ""
Else
  zeichennext$ = Left$(a$, ai% - 1): a$ = Mid$(a$, ai% + Len(ch$))
End If

End Function

