VERSION 2.00
Begin Form Baum 
   BackColor       =   &H00C0C0C0&
   BorderStyle     =   3  'Nicht nderbar, doppelt
   Caption         =   "Statischer Baum"
   ClientHeight    =   4710
   ClientLeft      =   225
   ClientTop       =   960
   ClientWidth     =   4710
   Height          =   5400
   Icon            =   BAUM.FRX:0000
   Left            =   165
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4710
   ScaleWidth      =   4710
   Top             =   330
   Width           =   4830
   Begin ListBox EbenenListe 
      Height          =   225
      Left            =   3120
      TabIndex        =   5
      Top             =   3600
      Visible         =   0   'False
      Width           =   1215
   End
   Begin ListBox XPosTabelle 
      Height          =   225
      Left            =   3120
      TabIndex        =   4
      Top             =   3960
      Visible         =   0   'False
      Width           =   1215
   End
   Begin ListBox ModulListe 
      Height          =   225
      Left            =   3120
      TabIndex        =   3
      Top             =   2520
      Visible         =   0   'False
      Width           =   1200
   End
   Begin ListBox AufrufListe 
      Height          =   225
      Left            =   3120
      Sorted          =   -1  'True
      TabIndex        =   2
      Top             =   3240
      Visible         =   0   'False
      Width           =   1200
   End
   Begin ListBox ProcListe 
      Height          =   225
      Left            =   3120
      TabIndex        =   1
      Top             =   2880
      Visible         =   0   'False
      Width           =   1200
   End
   Begin Outline Tree 
      Height          =   4455
      Left            =   120
      PictureClosed   =   BAUM.FRX:0302
      PictureLeaf     =   BAUM.FRX:03E4
      PictureMinus    =   BAUM.FRX:04C6
      PictureOpen     =   BAUM.FRX:05A8
      PicturePlus     =   BAUM.FRX:068A
      TabIndex        =   0
      Top             =   120
      Width           =   4455
   End
   Begin Menu menu_datei 
      Caption         =   "&Datei"
      Begin Menu menu_open 
         Caption         =   "&Projekt ffnen..."
      End
      Begin Menu menu_d 
         Caption         =   "-"
      End
      Begin Menu menu_ende 
         Caption         =   "&Ende"
      End
   End
   Begin Menu menu_fkt 
      Caption         =   "&Baum"
      Index           =   3
      Begin Menu menu_neuerstellen 
         Caption         =   "&Neu erstellen"
      End
      Begin Menu menu_b1 
         Caption         =   "-"
      End
      Begin Menu menu_grafik 
         Caption         =   "&Grafik anzeigen"
      End
   End
   Begin Menu menu_optionen 
      Caption         =   "&Optionen"
      Index           =   3
      Begin Menu menu_tiefe 
         Caption         =   "Tiefe = 1"
         Checked         =   -1  'True
         Index           =   1
      End
      Begin Menu menu_tiefe 
         Caption         =   "Tiefe rekursiv"
         Index           =   2
      End
   End
   Begin Menu menu_hilfe 
      Caption         =   "&Hilfe"
      Begin Menu menu_about 
         Caption         =   "ber..."
      End
   End
End

Sub erstelle_modul_liste ()

'Modul/Form-Liste erstellen

maus 0
   
Caption = "Statischer Baum  [" + projekt$ + "]"
App.Title = Caption

ModulListe.Clear

pfad$ = get_pfad$(projekt$)
Open projekt$ For Input As #1
Do Until EOF(1)
   Line Input #1, frm$
   If LCase$(Right$(projekt$, 4)) = ".mak" Then
      If InStr(frm$, "=") = 0 Then
         a$ = addpfad$(pfad$, frm$)
         b$ = get_file$(a$) + "," + get_pfad$(a$)
         If InStr(LCase$(frm$), ".bas") > 0 Then
            ModulListe.AddItem b$
         ElseIf InStr(LCase$(frm$), ".frm") > 0 Then
            ModulListe.AddItem b$
         End If
      End If
   Else
      b$ = zeichennext$(frm$, "="): a$ = Trim$(frm$)
      If b$ = "Form" Then
         a$ = ShortFilename$(addpfad$(pfad$, a$))
         b$ = get_file$(a$) + "," + get_pfad$(a$)
         ModulListe.AddItem b$
      ElseIf b$ = "Module" Then
         b$ = zeichennext$(a$, ";"): a$ = Trim$(a$)
         a$ = ShortFilename$(addpfad$(pfad$, a$))
         b$ = get_file$(a$) + "," + get_pfad$(a$)
         ModulListe.AddItem b$
      End If
   End If
Loop
Close #1

For n% = 1 To ModulListe.ListCount
   a$ = ModulListe.List(n% - 1): b$ = zeichennext$(a$, ",")
   ModulListe.List(n% - 1) = a$ + b$
Next

If exist%(get_pfad$(projekt$) + zeichennext$(get_file$(projekt$), ".") + ".str") Then
   menu_grafik.Enabled = True
   menu_tiefe(1).Enabled = True
   menu_tiefe(2).Enabled = True
   baum_anzeigen
Else
   Tree.Clear
   menu_grafik.Enabled = False
   menu_tiefe(1).Enabled = False
   menu_tiefe(2).Enabled = False
End If

maus 1

End Sub

Sub Form_Load ()

projekt$ = LCase$(Command$)

If Len(projekt$) Then
   erstelle_modul_liste
Else
   menu_grafik.Enabled = False
   menu_neuerstellen.Enabled = False
   menu_tiefe(1).Enabled = False
   menu_tiefe(2).Enabled = False
End If

End Sub

Sub menu_about_Click ()

MsgBox "Erstellt von" + Chr$(10) + "Dipl.-Ing. Thomas Fssl" + Chr$(10) + "EMail: 100327.2574@compuserve.com" + Chr$(10) + Chr$(10) + "Januar 1997", 64, "Statischer Baum"

End Sub

Sub menu_ende_Click ()

End

End Sub

Sub menu_grafik_Click ()

maus 0

'Liste aller Prozeduren einlesen
ProcListe.Clear
For f% = 1 To Tree.ListCount
   If Tree.Indent(f% - 1) = 1 Then
      ProcListe.AddItem Tree.List(f% - 1)
      ProcListe.ItemData(ProcListe.NewIndex) = f%
   End If
Next

'Liste aller Verweise erstellen
EbenenListe.Clear
ebene% = 1
For p% = 1 To ProcListe.ListCount
   EbenenListe.AddItem aufgerufene_proc$(p%)
   EbenenListe.ItemData(p% - 1) = ebene%
Next

'jeder Prozedur eine Ebene zuweisen
Do
   f% = 0
   For n% = 1 To ProcListe.ListCount
      If EbenenListe.ItemData(n% - 1) = ebene% Then
         a$ = EbenenListe.List(n% - 1)
         Do While Len(a$)
            nach% = Val(zeichennext$(a$, ";"))
            If n% <> nach% And (EbenenListe.ItemData(nach% - 1) = 1 Or EbenenListe.ItemData(nach% - 1) = ebene%) Then
               EbenenListe.ItemData(nach% - 1) = ebene% + 1
               f% = 1
            End If
         Loop
      End If
   Next
   ebene% = ebene% + 1
Loop While f%
ebene_anz% = ebene%

'X-Positionen der Prozeduren berechnen
XPosTabelle.Clear
For n% = 1 To ProcListe.ListCount: XPosTabelle.AddItem "": Next
xxmax = 0: zz% = 0
For ebene% = 1 To ebene_anz%
   xx = 100: z% = 0
   For n% = 1 To ProcListe.ListCount
      If EbenenListe.ItemData(n% - 1) = ebene% Then
         a$ = ProcListe.List(n% - 1)
         If InStr(a$, ".") Then e$ = zeichennext$(a$, ".")
         XPosTabelle.List(n% - 1) = Str$(xx + BaumGrafik.Pic.TextWidth(a$) / 2)
         xx = xx + BaumGrafik.Pic.TextWidth(a$ + "            ")
         z% = z% + 1
      End If
   Next
   If xx > xxmax Then xxmax = xx: zz% = z%
Next
xxmax = xxmax - BaumGrafik.Pic.TextWidth("            ")
If zz% > 1 Then
   BaumGrafik.HScroll1.Max = zz% - 1
   BaumGrafik.HScroll1.Tag = Str$(xxmax / zz%)
End If
BaumGrafik.VScroll1.Max = ebene_anz%

BaumGrafik.Show 1

End Sub

Sub menu_neuerstellen_Click ()

maus 0

Tree.Clear : Tree.Refresh
AufrufListe.Clear
ProcListe.Clear

'************* Sub/Function-Liste erstellen

Caption = "Statischer Baum: 1/3"

For p% = 1 To ModulListe.ListCount
   d$ = ModulListe.List(p% - 1)
   If LCase$(Right$(d$, 4)) = ".frm" Then p0% = p% Else p0% = 0
   Open d$ For Input As #1
   Do Until EOF(1)
      Line Input #1, a$
      a$ = Trim$(a$)
      If is_sub_or_function%(a$) Then
         z$ = zeichennext$(a$, " "): a$ = Trim$(a$)
         If z$ = "Public" Or z$ = "Private" Then z$ = Trim$(zeichennext$(a$, " ")): a$ = Trim$(a$)
         z$ = Trim$(zeichennext$(a$, "("))
         ProcListe.AddItem z$
         ProcListe.ItemData(ProcListe.NewIndex) = p0%
      End If
   Loop
   Close #1
Next

'************* Aufruf-Liste erstellen

Caption = "Statischer Baum: 2/3, 0%"

For p% = 1 To ModulListe.ListCount
   pr$ = ModulListe.List(p% - 1)
   If LCase$(Right$(pr$, 4)) = ".frm" Then pn$ = formname$(pr$) + "." Else pn$ = ""
   Open pr$ For Input As #1
   Do Until EOF(1)
      Line Input #1, a$
      a$ = Trim$(a$)
      If is_sub_or_function%(a$) Then
         z$ = zeichennext$(a$, " "): a$ = Trim$(a$)
         If z$ = "Public" Or z$ = "Private" Then z$ = Trim$(zeichennext$(a$, " ")): a$ = Trim$(a$)
         fu$ = Trim$(zeichennext$(a$, "("))
      Else
         s$ = "|"
         For i% = 1 To ProcListe.ListCount
            proc$ = ProcListe.List(i% - 1)
            If ProcListe.ItemData(i% - 1) <> p% And ProcListe.ItemData(i% - 1) > 0 Then
               proc$ = formname$(ModulListe.List(ProcListe.ItemData(i% - 1) - 1)) + "." + proc$
            End If
            If innen%(a$, proc$) Then
               AufrufListe.AddItem pn$ + fu$
               AufrufListe.ItemData(AufrufListe.NewIndex) = i%
            End If
            DoEvents
         Next
      End If
   Loop
   Close #1
   Caption = "Statischer Baum: 2/3," + Str$(Int(100 * p% / ModulListe.ListCount + .5)) + "%"
Next

'************* Baum-Liste erstellen

Caption = "Statischer Baum: 3/3, 0%"

Open get_pfad$(projekt$) + zeichennext$(get_file$(projekt$), ".") + ".str" For Output As #1
For f% = 1 To ProcListe.ListCount
   fu$ = ProcListe.List(f% - 1)
   it% = ProcListe.ItemData(f% - 1)
   If it% Then fu$ = formname$(ModulListe.List(it% - 1)) + "." + fu$
   Print #1, "["; fu$; "]"
   s$ = "|"
   For f2% = 1 To AufrufListe.ListCount
      a$ = AufrufListe.List(f2% - 1)
      ff% = AufrufListe.ItemData(f2% - 1)
      ruf$ = ProcListe.List(ff% - 1)
      it% = ProcListe.ItemData(ff% - 1)
      If it% Then ruf$ = formname$(ModulListe.List(it% - 1)) + "." + ruf$
      If a$ = fu$ And InStr(s$, "|" + ruf$ + "|") = 0 Then
         s$ = s$ + ruf$ + "|"
         Print #1, ruf$
      End If
      DoEvents
   Next
   Print #1,
   Caption = "Statischer Baum: 3/3," + Str$(Int(100# * f% / ProcListe.ListCount + .5)) + "%"
Next
Close #1

'*************

maus 1

baum_anzeigen

menu_grafik.Enabled = True
menu_tiefe(1).Enabled = True
menu_tiefe(2).Enabled = True

Caption = "Statischer Baum  [" + projekt$ + "]"

End Sub

Sub menu_open_Click ()

pfad$ = get_pfad$(projekt$)
a$ = Dialog_Open$(Me, "Projekt ffnen", pfad$, get_file$(projekt$), "VB-Projekte|*.mak;*.vbp|VB3-Projekte|*.mak|VB4-Projekte|*.vbp|Alle Dateien (*.*)|*.*", "mak")

If Len(a$) Then
   projekt$ = LCase$(pfad$ + a$)
   erstelle_modul_liste
   menu_neuerstellen.Enabled = True
End If

End Sub

Sub menu_tiefe_Click (Index As Integer)

menu_tiefe(1).Checked = Index = 1
menu_tiefe(2).Checked = Index = 2

baum_anzeigen

End Sub

Sub Tree_Click ()

Tree.Expand(Tree.ListIndex) = Not Tree.Expand(Tree.ListIndex)

End Sub

